#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <stdlib.h>
#include <io.h>

#include <dos.h>
/* example application for set/clear gpio's(0-3). gpio numbers are assumed according the 
  CAMI connector 

/*   Defines for GPIO[15:0].
DIVIL_GPIOL_OUT_VAL             = 000h  ; GPIO low bank output value.
DIVIL_GPIOL_OUT_EN              = 004h  ; GPIO low bank output enable.
DIVIL_GPIOL_OUT_OD_EN           = 008h  ; GPIO low bank output open-drain enable.
DIVIL_GPIOL_OUT_INV_EN          = 00ch  ; GPIO low bank output invert enable.
DIVIL_GPIOL_OUT_AUX1_SEL        = 010h  ; GPIO low bank output auxiliary 1 select.
DIVIL_GPIOL_OUT_AUX2_SEL        = 014h  ; GPIO low bank output auxiliary 2 select.
DIVIL_GPIOL_PU_EN               = 018h  ; GPIO low bank pull-up enable.
DIVIL_GPIOL_PD_EN               = 01ch  ; GPIO low bank pull-down enable.
DIVIL_GPIOL_IN_EN               = 020h  ; GPIO low bank input enable.
DIVIL_GPIOL_IN_INV_EN           = 024h  ; GPIO low bank input invert enable.
DIVIL_GPIOL_IN_FIL_EN           = 028h  ; GPIO low bank input filter enable.
DIVIL_GPIOL_IN_EVC_EN           = 02ch  ; GPIO low bank input event count enable.
DIVIL_GPIOL_READ_BACK           = 030h  ; GPIO low bank read back.
DIVIL_GPIOL_IN_AUX1_SEL         = 034h  ; GPIO low bank input auxiliary 1 select.
DIVIL_GPIOL_EVENTS_EN           = 038h  ; GPIO low bank events enable.
DIVIL_GPIOL_LOCK_EN             = 03ch  ; GPIO low bank lock enable.
DIVIL_GPIOL_IN_PE_EN            = 040h  ; GPIO low bank input positive edge enable.
DIVIL_GPIOL_IN_NE_EN            = 044h  ; GPIO low bank input negative edge enable.
DIVIL_GPIOL_IN_PE_STS           = 048h  ; GPIO low bank input positive edge status.
DIVIL_GPIOL_IN_NE_STS           = 04ch  ; GPIO low bank input negative edge status.

       Defines for GPIO[31:16].

DIVIL_GPIOH_OUT_VAL             = 080h  ; GPIO high bank output value.
DIVIL_GPIOH_OUT_EN              = 084h  ; GPIO high bank output enable.
DIVIL_GPIOH_OUT_OD_EN           = 088h  ; GPIO high bank output open-drain enable.
DIVIL_GPIOH_OUT_INV_EN          = 08ch  ; GPIO high bank output invert enable.
DIVIL_GPIOH_OUT_AUX1_SEL        = 090h  ; GPIO high bank output auxiliary 1 select.
DIVIL_GPIOH_OUT_AUX2_SEL        = 094h  ; GPIO high bank output auxiliary 2 select.
DIVIL_GPIOH_PU_EN               = 098h  ; GPIO high bank pull-up enable.
DIVIL_GPIOH_PD_EN               = 09ch  ; GPIO high bank pull-down enable.
DIVIL_GPIOH_IN_EN               = 0a0h  ; GPIO high bank input enable.
DIVIL_GPIOH_IN_INV_EN           = 0a4h  ; GPIO high bank input invert enable.
DIVIL_GPIOH_IN_FIL_EN           = 0a8h  ; GPIO high bank input filter enable.
DIVIL_GPIOH_IN_EVC_EN           = 0ach  ; GPIO high bank input event count enable.
DIVIL_GPIOH_READ_BACK           = 0b0h  ; GPIO high bank read back.
DIVIL_GPIOH_IN_AUX1_SEL         = 0b4h  ; GPIO high bank input auxiliary 1 select.
DIVIL_GPIOH_EVENTS_EN           = 0b8h  ; GPIO high bank events enable.
DIVIL_GPIOH_LOCK_EN             = 0bch  ; GPIO high bank lock enable.
DIVIL_GPIOH_IN_PE_EN            = 0c0h  ; GPIO high bank input positive edge enable.
DIVIL_GPIOH_IN_NE_EN            = 0c4h  ; GPIO high bank input negative edge enable.
DIVIL_GPIOH_IN_PE_STS           = 0c8h  ; GPIO high bank input positive edge status.
DIVIL_GPIOH_IN_NE_STS           = 0cch  ; GPIO high bank input negative edge status.  


DIVIL_GPIO01_SET                = 00000002h ; atomic set for GPIO 01.
DIVIL_GPIO01_CLR                = 00020000h ; atomic clear for GPIO 01.

DIVIL_GPIO05_SET                = 00000020h ; atomic set for GPIO 05.(GPIO1)
DIVIL_GPIO05_CLR                = 00200000h ; atomic clear for GPIO 05.(GPIO1)

DIVIL_GPIO06_SET                = 00000040h ; atomic set for GPIO 06.(GPIO0)
DIVIL_GPIO06_CLR                = 00400000h ; atomic clear for GPIO 06.(GPIO0)

DIVIL_GPIO20_SET                = 00000010h ; atomic set for GPIO 20.
DIVIL_GPIO20_CLR                = 00100000h ; atomic clear for GPIO 20.

DIVIL_GPIO21_SET                = 00000020h ; atomic set for GPIO 21.
DIVIL_GPIO21_CLR                = 00200000h ; atomic clear for GPIO 21.

DIVIL_GPIO25_SET                = 00000200h ; atomic set for GPIO 25.(GPIO3)
DIVIL_GPIO25_CLR                = 02000000h ; atomic clear for GPIO 25.(GPIO3)

DIVIL_GPIO26_SET                = 00000400h ; atomic set for GPIO 26.
DIVIL_GPIO26_CLR                = 04000000h ; atomic clear for GPIO 26.

DIVIL_GPIO27_SET                = 00000800h ; atomic set for GPIO 27.(GPIO2)
DIVIL_GPIO27_CLR                = 08000000h ; atomic clear for GPIO 27.(GPIO2)

*/
#define BASE_LOW_BANK                   0x000
#define BASE_HIGH_BANK                  0x080

#define DIVIL_GPIO_OUT_VAL             0x000 
#define DIVIL_GPIO_OUT_EN              0x004 
#define DIVIL_GPIO_OUT_OD_EN           0x008  
#define DIVIL_GPIO_OUT_INV_EN          0x00c  
#define DIVIL_GPIO_OUT_AUX1_SEL        0x010  
#define DIVIL_GPIO_OUT_AUX2_SEL        0x014  
#define DIVIL_GPIO_PU_EN               0x018  
#define DIVIL_GPIO_PD_EN               0x01c  
#define DIVIL_GPIO_IN_EN               0x020  
#define DIVIL_GPIO_IN_INV_EN           0x024  
#define DIVIL_GPIO_IN_FIL_EN           0x028 
#define DIVIL_GPIO_IN_EVC_EN           0x02c  
#define DIVIL_GPIO_READ_BACK           0x030  
#define DIVIL_GPIO_IN_AUX1_SEL         0x034 
#define DIVIL_GPIO_EVENTS_EN           0x038 
#define DIVIL_GPIO_LOCK_EN             0x03c  
#define DIVIL_GPIO_IN_PE_EN            0x040  
#define DIVIL_GPIO_IN_NE_EN            0x044 
#define DIVIL_GPIO_IN_PE_STS           0x048  
#define DIVIL_GPIO_IN_NE_STS           0x04c  


#define DIVIL_GPIO01_SET                0x00000002
#define DIVIL_GPIO01_CLR                0x00020000

#define DIVIL_GPIO05_SET                0x00000020
#define DIVIL_GPIO05_CLR                0x00200000

#define DIVIL_GPIO06_SET                0x00000040
#define DIVIL_GPIO06_CLR                0x00400000

#define DIVIL_GPIO20_SET                0x00000010
#define DIVIL_GPIO20_CLR                0x00100000

#define DIVIL_GPIO21_SET                0x00000020
#define DIVIL_GPIO21_CLR                0x00200000

#define DIVIL_GPIO25_SET                0x00000200
#define DIVIL_GPIO25_CLR                0x02000000

#define DIVIL_GPIO26_SET                0x00000400
#define DIVIL_GPIO26_CLR                0x04000000 

#define DIVIL_GPIO27_SET                0x00000800 
#define DIVIL_GPIO27_CLR                0x08000000

enum {TIMER_OUT=4,LPC_LDRQ,SERIRQ,PME};
unsigned short GPIO_BASE=0;  
unsigned long  lookuptable[] =  {6,5,27,25,1,20,21,26};/*GPIO look up table*/

unsigned short GetGPIO(unsigned short gpio_num);
void SetGPIO(unsigned short gpio_num);
void ClearGPIO(unsigned short gpio_num);
void InitGPIO(int gpio_num);
void ReadGPIOBase();

/*--------------------Helper functions ---------------------------------------*/
int ReadMSR(unsigned long addr,unsigned long *val1,unsigned long *val2)
{
  /*ecx  =MSR address;
  val1 = eax ,val2=edx;*/
    unsigned short add1, add2,out11,out12,out21,out22;
      add1 = (unsigned short)((addr>>16)&0x0000FFFF);
      add2 = (unsigned short)(addr&0x0000FFFF);
    __asm {
        mov cx,add1
        db 066h // operand size override prefix (force 32-bit)
        shl cx,16
        mov cx,add2
        
        db 0x0f
        db 0x32
       
        mov out12,ax
        db 066h // operand size override prefix (force 32-bit)
        shr ax ,16
        mov out11,ax
        
        mov out22,dx
        db 066h // operand size override prefix (force 32-bit)
        shr dx ,16
        mov out21,dx
       }
       if(val1)
       {
       *val1 = ((((unsigned long)(out11))<<16)|(unsigned long)(out12));
       }
         if(val2)
       {      
       *val2 = ((((unsigned long)(out21))<<16)|(unsigned long)(out22));       
       }
    return 0;


}
void WriteMSR(unsigned long addr,unsigned long val1,unsigned long val2)
{
  /*ecx  =MSR address;
  val1 = eax ,val2=edx;*/
    unsigned short add1, add2,out11=0,out12=0,out21=0,out22=0;

      add1 = (unsigned short)((addr>>16)&0x0000FFFF);
      add2 = (unsigned short)(addr&0x0000FFFF);
      if(val1)
      {
      out11 = (unsigned short)((val1>>16)&0x0000FFFF);
      out12 = (unsigned short)(val1&0x0000FFFF);
      }
      if(val2)
      {
      out21 = (unsigned short)((val2>>16)&0x0000FFFF);
      out22 = (unsigned short)(val2&0x0000FFFF);
      } 
    __asm {
        mov cx,add1
        db 066h // operand size override prefix (force 32-bit)
        shl cx,16
        mov cx,add2
        
        mov ax,out11
        db 066h // operand size override prefix (force 32-bit)
        shl ax,16
        mov ax,out12
        
        mov dx,out21
        db 066h // operand size override prefix (force 32-bit)
        shl dx,16
        mov dx,out22
        
        
        db 0x0f
        db 0x30
      
       
       }
}
unsigned long in_d(unsigned short addr)
{
    unsigned short res1, res2;
    __asm {
        mov dx, addr
        db 0x66 // operand size override prefix (force 32-bit)
        in ax, dx
        mov res1, ax
        db 066h // operand size override prefix (force 32-bit)
        shr ax, 16
        mov res2, ax
    }
    return (res1+(((unsigned long)res2)<<16));
}

void out_d(unsigned short addr, unsigned long val)
{
    unsigned short arg1, arg2;
    arg1=val&0x0000FFFF;
    arg2=(val>>16)&0x0000FFFF;
    __asm {
        mov dx, addr
        mov ax, arg2
        db 0x66 // operand size override prefix (force 32-bit)
        shl ax, 16
        mov ax, arg1
        db 066h // operand size override prefix (force 32-bit)
        out dx, ax
    }
}
/*-----------------------------------------------------------------------------*/
void ReadGPIOBase()
{
  unsigned long val =0;
    ReadMSR(0x5140000c,&val,0);
    GPIO_BASE =(unsigned short)val;
    printf("\nGPIO base - %x",GPIO_BASE);
    return;
  

}
/*-----------------------------------------------------------------------------*/
void InitGPIO(int gpio_num)
{
/* reset the GPIO into known state*/
  unsigned long orig_gpio =lookuptable[gpio_num];
  
  int high_low_bank=BASE_LOW_BANK;
  unsigned long gpio_xx_clear=0;
  int xx=0;

  if(orig_gpio>16)
  {/*high bank gpio*/
       high_low_bank =BASE_HIGH_BANK;
  }
  gpio_xx_clear = ((unsigned long)(1<<(orig_gpio%16)&0x0000ffff))<<16;
  printf("\nInit GPIO %d(%d)",gpio_num,orig_gpio);
  for (xx=0;xx<=0x38;xx+=4)
  {/* according with the table of defines from 0x000 to 0x04c*/
    out_d(GPIO_BASE+high_low_bank+xx,gpio_xx_clear);
  }
  out_d(GPIO_BASE+high_low_bank+0x3c,0);
    for (xx=40;xx<=0x4c;xx+=4)
  {/* according with the table of defines from 0x000 to 0x04c*/
    out_d(GPIO_BASE+high_low_bank+xx,gpio_xx_clear);
  }
  return;
}
/*-----------------------------------------------------------------------------*/
/* Sets up specified gpio as output and writes 0*/
void ClearGPIO(unsigned short gpio_num)
{
   unsigned long  orig_gpio =lookuptable[gpio_num];
  int high_low_bank=BASE_LOW_BANK;
  unsigned long gpio_xx_clear=0;
  unsigned long gpio_xx_set=0;
  
  if(orig_gpio>16)
  {/*high bank gpio*/
       high_low_bank =BASE_HIGH_BANK;
  }
  gpio_xx_set = (1<<(orig_gpio%16)&0x0000ffff);
  gpio_xx_clear = gpio_xx_set<<16;
  printf("\nClearing GPIO %d(%d)",gpio_num,orig_gpio);
  out_d(GPIO_BASE+high_low_bank+DIVIL_GPIO_OUT_EN,gpio_xx_set);
  out_d(GPIO_BASE+high_low_bank+DIVIL_GPIO_OUT_VAL,gpio_xx_clear);

}
/*-----------------------------------------------------------------------------*/
/* Sets up specified gpio as output and writes 1*/
void SetGPIO(unsigned short gpio_num)
{
 unsigned long  orig_gpio =lookuptable[gpio_num];
  int high_low_bank=BASE_LOW_BANK;
  unsigned long gpio_xx_set=0;
 
  if(orig_gpio>16)
  {/*high bank gpio*/
       high_low_bank =BASE_HIGH_BANK;
  }
  gpio_xx_set = (1<<(orig_gpio%16)&0x0000ffff);
  printf("\nSetting GPIO %d(%d)",gpio_num,orig_gpio);
  out_d(GPIO_BASE+high_low_bank+DIVIL_GPIO_OUT_EN,gpio_xx_set);
  out_d(GPIO_BASE+high_low_bank+DIVIL_GPIO_OUT_VAL,gpio_xx_set);

}
/*-----------------------------------------------------------------------------*/
/* Sets up specified gpio as input and reads it*/
unsigned short GetGPIO(unsigned short gpio_num)
{
 unsigned long  orig_gpio =lookuptable[gpio_num];
  int high_low_bank=BASE_LOW_BANK;
  unsigned long gpio_xx_set=0;
  unsigned long result=0;
 
  int decision=0;
  if(orig_gpio>16)
  {/*high bank gpio*/
       high_low_bank =BASE_HIGH_BANK;
  } 
   gpio_xx_set = (1<<(orig_gpio%16))&0x0000ffff;
 
  out_d(GPIO_BASE+high_low_bank+DIVIL_GPIO_IN_EN,gpio_xx_set);
   sleep(1);
  result=in_d((int)(GPIO_BASE+high_low_bank+DIVIL_GPIO_READ_BACK));
  decision=(int)result&gpio_xx_set;
   printf("\nReading GPIO %d(%d)->",gpio_num,orig_gpio); 
 if(decision>0)
   return 1;
  else
    return 0;
}
void SwitchToGPIO(unsigned short gpio_num)
{
    unsigned long val1 =0,val2=0,bit_flag=0xFFFFFFFF;
    
    switch(gpio_num)
    {
          case LPC_LDRQ: bit_flag  = 0xFFFFFFEF;
              printf("\nSwitching LPC_LDRQ to GPIO mode");
            break;
    
          case SERIRQ: bit_flag  = 0xFFFFFFDF;
          printf("\nSwitching SERIRQ to GPIO mode");
            break;
    }
    ReadMSR(0x51400015,&val1,&val2);
    WriteMSR(0x51400015,(val1&bit_flag),val2);


}
void SwitchToLPC(unsigned short gpio_num)
{
     unsigned long val1 =0,val2=0,bit_flag=0x00000000;
    
    switch(gpio_num)
    {
          case LPC_LDRQ: bit_flag  = 0x00000010;
              printf("\nSwitching LPC_LDRQ to LPC mode");
            break;
    
          case SERIRQ: bit_flag  = 0x00000020;
              printf("\nSwitching SERIRQ to LPC mode");
            break;
    }
    
    ReadMSR(0x51400015,&val1,&val2);
    WriteMSR(0x51400015,(val1|bit_flag),val2);



}

/*-----------------------------------------------------------------------------*/
int main()
{
 int xx=0;
  
 ReadGPIOBase();
   for(xx=0;xx<=3;xx++)
     InitGPIO(xx);
  
  printf("\n*********************************");
  SetGPIO(2);/* Led off*/
  sleep(1);
  ClearGPIO(2);/* Led on*/
   ClearGPIO(3);
  sleep(1);
  printf("\n*********************************");
  SetGPIO(0);
  ClearGPIO(1);
  SetGPIO(2);
  SetGPIO(3);
  printf("\n*********************************");
  printf("\nRead the GPIO status:");
  for(xx=0;xx<=3;xx++)
  {   
   printf(" %d",GetGPIO(xx));
  }
   /******************************************************************/
   /* shared GPIOs example*/
   printf("\n**********Shared GPIOs***********************");
   InitGPIO(TIMER_OUT);
   
   ClearGPIO(TIMER_OUT);
  
   
    InitGPIO(PME);
    SetGPIO(PME);
   /* ClearGPIO(PME);*/
   
  SwitchToGPIO(LPC_LDRQ) ;
  InitGPIO(LPC_LDRQ);
   ClearGPIO(LPC_LDRQ);
  /*SERIRQ is used by Cardbus on the ATX base so be careful with alternative usage!!!
   SwitchToGPIO(SERIRQ) ;
   InitGPIO(SERIRQ);
   SetGPIO(SERIRQ);*/
    SetGPIO(TIMER_OUT);
    
  printf(" %d",GetGPIO(TIMER_OUT));
  printf(" %d",GetGPIO(PME));
  printf(" %d",GetGPIO(LPC_LDRQ));
 
  /*to return GPIOs for LPC controller :
    SwitchToLPC(LPC_LDRQ);
    SwitchToLPC(SERIRQ);*/
	return 0;
}

